%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Kernel estimation of slope & gap
%%%%%%%% estimation Hospital by hospital
%%%%%%%%%% Original Y
 
clear
 
syms x;
  
      
Nsim = 500;          


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Analysis of scenario 0 (no error in the observed q)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

thetaL = zeros(4,Nsim);
thetaR = zeros(4,Nsim);
varslopeL= zeros(4,Nsim);
varslopeR= zeros(4,Nsim);
gap = zeros(4,Nsim);
gap_pvalue = zeros(4,Nsim);
slopeL = zeros(4,1); 
slopeR = zeros(4,1);
phi4 = zeros(4,1);
sephi4 = zeros(4,1); 
t_slope = zeros(4,1);

for kkk = 1:4
for iter = 1:Nsim
    if kkk == 1
    myfilename = sprintf('SimulatedData_optimal1_%d.txt', iter);
    elseif kkk == 2        
    myfilename = sprintf('SimulatedData_optimal2_%d.txt', iter);
    elseif kkk == 3        
    myfilename = sprintf('SimulatedData_optimal3_%d.txt', iter);
    else        
    myfilename = sprintf('SimulatedData_optimal4_%d.txt', iter);
    end   
 dataset  = importdata(myfilename);    
 % [new_inlier new_outlier new_bpr ph_billed_3_4 inlier_thres outlier_thres norm_bill_less_outlier vol sect1 sect2 sect3 sect hospital, abs(dis from qcut), distance from q2]

data_L = dataset;
data_L((data_L(:,12) ~= 2), :) = [];
data_R = dataset;
data_R((data_R(:,12) ~= 3), :) = [];
 
hospitalsize = size(dataset,1); 

% generate Y (q variable)
Y_L = data_L(:,14); 
Y_R = data_R(:,14); 
    
 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% L original Y, Silverman's %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
h =  1.3643*0.8918 * length(data_L(:,1))^-0.2*min( std(data_L(:,14)),(quantile(data_L(:,14),.75)-quantile(data_L(:,14),.25))/1.349) ; % L silverman  
a = max(data_L(:,14)) / h ;
T =  sqrt(2/3.14159265) * int(exp(-0.5*x^2),0,a);   
  
xx = 2/sqrt(2*pi)*exp(-0.5* (Y_L/h ).^2);
thetaL(kkk,iter)= sum(xx) / (hospitalsize * h*T) ;  
 
varslopeL(kkk,iter)  = 1/(hospitalsize *h  *thetaL(kkk,iter)^3) * 2/(3.14159265*T^2) * int(exp(-x^2),0,a); % se for 1/f1: use delta method + variance formula for kernel 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% R  original Y, Silverman's  %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
h =  1.3643*0.8918 * length(data_R(:,1))^-0.2*min( std(data_R(:,14)),(quantile(data_R(:,14),.75)-quantile(data_R(:,14),.25))/1.349) ; % L silverman  
a = max(data_R(:,14)) / h ;
T =  sqrt(2/3.14159265) * int(exp(-0.5*x^2),0,a);   
  
xx = 2/sqrt(2*pi)*exp(-0.5* (Y_R/h ).^2);
thetaR(kkk,iter)   = sum(xx) / (hospitalsize * h*T) ;  
 
varslopeR(kkk,iter)  =  1/(hospitalsize *h  *thetaR(kkk,iter)^3*T^2) * 2/3.14159265 * int(exp(-x^2),0,a) ; % se for 1/f1: use delta method + variance formula for kernel 
 
 
gap(kkk,iter) = min(data_R(:,15)) - max(data_L(:,15)) ;

gap_pvalue(kkk,iter) = double(1 - (1+thetaL(kkk,iter)/(thetaR(kkk,iter)-thetaL(kkk,iter))*exp(-thetaR(kkk,iter)*hospitalsize*gap(kkk,iter))...
                   - thetaR(kkk,iter)/(thetaR(kkk,iter)-thetaL(kkk,iter))*exp(-thetaL(kkk,iter)*hospitalsize*gap(kkk,iter))));
         
               % reject no gap if pvalue less than 0.05 
     
end;  
kkk
end;    


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Analysis of scenarios 1-6 (observed q contains error of various kinds and magnitudes
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


mean(gap,2) % sample size = [5000,1000,500,100]
%std(gap,0,2)
quantile(gap, .025,2) 
quantile(gap, .975,2) 
mean(gap_pvalue,2)

 
thetaL_error = zeros(24,Nsim);
thetaR_error = zeros(24,Nsim);
varslopeL_error= zeros(24,Nsim);
varsloper_error= zeros(24,Nsim);
gap_error = zeros(24,Nsim);
gap_error_pvalue = zeros(24,Nsim);
slopeL_error = zeros(24,1); 
slopeR_error = zeros(24,1);
phi4_error = zeros(24,1);
sephi4_error = zeros(24,1); 
t_slope_error = zeros(24,1);


for kkk = 1:24
for iter = 1:Nsim

    if kkk == 1
myfilename = sprintf('SimulatedData1_%d.txt', iter);
    elseif kkk == 2
myfilename = sprintf('SimulatedData2_%d.txt', iter);
    elseif kkk == 3
myfilename = sprintf('SimulatedData3_%d.txt', iter);
    elseif kkk == 4
myfilename = sprintf('SimulatedData4_%d.txt', iter);
    elseif kkk == 5
myfilename = sprintf('SimulatedData5_%d.txt', iter);
    elseif kkk == 6
myfilename = sprintf('SimulatedData6_%d.txt', iter);
    elseif kkk == 7
myfilename = sprintf('SimulatedData7_%d.txt', iter);
    elseif kkk == 8
myfilename = sprintf('SimulatedData8_%d.txt', iter);
    elseif kkk == 9
myfilename = sprintf('SimulatedData9_%d.txt', iter);
    elseif kkk == 10
myfilename = sprintf('SimulatedData10_%d.txt', iter);
    elseif kkk == 11
myfilename = sprintf('SimulatedData11_%d.txt', iter);
    elseif kkk == 12
myfilename = sprintf('SimulatedData12_%d.txt', iter);
    elseif kkk == 13
myfilename = sprintf('SimulatedData13_%d.txt', iter);
    elseif kkk == 14
myfilename = sprintf('SimulatedData14_%d.txt', iter);
    elseif kkk == 15
myfilename = sprintf('SimulatedData15_%d.txt', iter);
    elseif kkk == 16
myfilename = sprintf('SimulatedData16_%d.txt', iter);
    elseif kkk == 17
myfilename = sprintf('SimulatedData17_%d.txt', iter);
    elseif kkk == 18
myfilename = sprintf('SimulatedData18_%d.txt', iter);
    elseif kkk == 19
myfilename = sprintf('SimulatedData19_%d.txt', iter);
    elseif kkk == 20
myfilename = sprintf('SimulatedData20_%d.txt', iter);
    elseif kkk == 21
myfilename = sprintf('SimulatedData21_%d.txt', iter);
    elseif kkk == 22
myfilename = sprintf('SimulatedData22_%d.txt', iter);
    elseif kkk == 23
myfilename = sprintf('SimulatedData23_%d.txt', iter);
    else 
myfilename = sprintf('SimulatedData24_%d.txt', iter);
    end
        
dataset = importdata(myfilename);        
        
 % [new_inlier new_outlier new_bpr ph_billed_3_4 inlier_thres outlier_thres norm_bill_less_outlier vol sect1 sect2 sect3 sect hospital,, abs(dis from qcut), distance from q2]

  
data_L = dataset;
data_L((data_L(:,12) ~= 2), :) = [];
  
data_R = dataset;
data_R((data_R(:,12) ~= 3), :) = [];
 
hospitalsize = size(dataset,1); 
% generate Y (q variable)
Y_L = data_L(:,14); 
Y_R = data_R(:,14); 
    
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% L original Y, Silverman's %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
h =   1.3643*0.8918 * length(data_L(:,1))^-0.2*min( std(data_L(:,14)),(quantile(data_L(:,14),.75)-quantile(data_L(:,14),.25))/1.349) ; % L silverman  
a = max(data_L(:,14)) / h ;
T =  sqrt(2/3.14159265) * int(exp(-0.5*x^2),0,a);   
 
  
xx = 2/sqrt(2*pi)*exp(-0.5* (Y_L/h ).^2);
thetaL_error(kkk,iter)   = sum(xx) / (hospitalsize * h*T) ;  
varslopeL_error(kkk,iter)  =  1/(hospitalsize *h  *thetaL_error(kkk,iter)^3) * 2/(3.14159265*T^2) * int(exp(-x^2),0,a) ; % se for 1/f1: use delta method + variance formula for kernel 

 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% R  original Y, Silverman's  %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
h =   1.3643*0.8918 * length(data_R(:,1))^-0.2*min( std(data_R(:,14)),(quantile(data_R(:,14),.75)-quantile(data_R(:,14),.25))/1.349) ; % R silverman  
a = max(data_R(:,14)) / h ;
T =  sqrt(2/3.14159265) * int(exp(-0.5*x^2),0,a);   
  
xx = 2/sqrt(2*pi)*exp(-0.5* (Y_R/h ).^2);
thetaR_error(kkk,iter)   = sum(xx) / (hospitalsize * h*T) ;  
varslopeR_error(kkk,iter)  =  1/(hospitalsize *h  *thetaR_error(kkk,iter)^3*T^2) * 2/3.14159265 * int(exp(-x^2),0,a) ; % se for 1/f1: use delta method + variance formula for kernel 
 
gap_error(kkk,iter) = min(data_R(:,15)) - max(data_L(:,15)) ;
  
gap_error_pvalue(kkk,iter) = double(1 - (1+thetaL_error(kkk,iter)/(thetaR_error(kkk,iter)-thetaL_error(kkk,iter))*exp(-thetaR_error(kkk,iter)*hospitalsize*gap_error(kkk,iter))...
                   - thetaR_error(kkk,iter)/(thetaR_error(kkk,iter)-thetaL_error(kkk,iter))*exp(-thetaL_error(kkk,iter)*hospitalsize*gap_error(kkk,iter))));
               
     
end    
kkk


mean(gap_error,2) % sample size = [5000*6,1000*6,500*6,100*6]
quantile(gap_error, .025,2) 
quantile(gap_error, .975,2) 
mean(gap_error_pvalue,2)
end

       
mean(gap_error,2) % sample size = [5000*6,1000*6,500*6,100*6]
quantile(gap_error, .025,2) 
quantile(gap_error, .975,2) 
mean(gap_error_pvalue,2)