%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Kernel estimation of phi4
%%%%%%%% estimation Hospital by hospital
%%%%%%%%%% Original Y
clear

 
syms x;
  
bmtdata= xlsread('kerneldata_bmt.xls'); 
nhospital = max(bmtdata(:,13)); % number of hospitals


bmt_L = bmtdata;
bmt_L((bmtdata(:,12) ~= 2), :) = []; 
bmt_R = bmtdata;
bmt_R((bmtdata(:,12) ~= 3), :) = [];
bmt_LR = [bmt_L; bmt_R];
   
      
bmt_L_hosp = cell([nhospital 1]);
bmt_R_hosp = cell([nhospital 1]);

for i = 1:nhospital 
bmt_L_hosp{i} = bmt_L;
bmt_L_hosp{i}((bmt_L(:,13) ~= i), :) = [];
bmt_R_hosp{i} = bmt_R;
bmt_R_hosp{i}((bmt_R(:,13) ~= i), :) = [];
hospitalsize_bmt(i)  =  sum(bmtdata(:,13) == i);
end
     
  
% generate Y (q variable)
Ybmt_L = bmt_L(:,14); 
Ybmt_R = bmt_R(:,14); 
  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% L kernel density, BMT, original Y %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

thetaL_bmt = zeros(nhospital,1);
varslopeL_bmt = zeros(nhospital,1);  

    
for i = 1:nhospital 
h(i) =  1.3643*0.8918 * (length(bmt_L_hosp{i}(:,1)))^-0.2*min( std(bmt_L_hosp{i}(:,14)),(quantile(bmt_L_hosp{i}(:,14),.75)-quantile(bmt_L_hosp{i}(:,14),.25))/1.349) ; % L silverman  
a(i) = max(bmt_L_hosp{i}(:,14))/h(i); 
T(i) =  sqrt(2/3.14159265) * int(exp(-0.5*x^2),0,a(i));    
end
 
 
    for i = 1:nhospital % kernel density for each hospital
           for j = 1:size(bmt_L,1);
               if bmt_L(j,13) == i
                   thetaL_bmt(i) = thetaL_bmt(i) + 2/sqrt(2*pi)*exp(-0.5* (Ybmt_L(j)/h(i))^2);
               end
           end
           thetaL_bmt(i) = thetaL_bmt(i) / (hospitalsize_bmt(i) * h(i)* T(i)); 
    end
  
     for i = 1:nhospital % kernel density for each hospital
        varslopeL_bmt(i) = 1/(hospitalsize_bmt(i)*h(i) *thetaL_bmt(i)^3) * 2/(3.14159265* T(i)^2) * int(exp(-x^2),0,a(i)); % se for 1/f1: use delta method + variance formula for kernel 
     end
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% R kernel density, BMT, original Y %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

thetaR_bmt = zeros(nhospital,1); %
varslopeR_bmt = zeros(nhospital,1);  
 
for i = 1:nhospital 
h(i) =  1.3643*0.8918 * (length(bmt_R_hosp{i}(:,1)))^-0.2*min( std(bmt_R_hosp{i}(:,14)),(quantile(bmt_R_hosp{i}(:,14),.75)-quantile(bmt_R_hosp{i}(:,14),.25))/1.349) ; % L silverman  
a(i) = max(bmt_R_hosp{i}(:,14))/h(i); 
T(i) =  sqrt(2/3.14159265) * int(exp(-0.5*x^2),0,a(i));    
end

 
    for i = 1:nhospital % kernel density for each hospital
           for j = 1:size(bmt_R,1);
               if bmt_R(j,13) == i
                  thetaR_bmt(i) = thetaR_bmt(i) + 2/sqrt(2*pi)*exp(-0.5* (Ybmt_R(j)/h(i) )^2);
               end
           end
           thetaR_bmt(i) = thetaR_bmt(i) / (hospitalsize_bmt(i)*h(i)* T(i));            
    end
 
     for i = 1:nhospital % kernel density for each hospital
        varslopeR_bmt(i) =  1/(hospitalsize_bmt(i)*h(i) *thetaR_bmt(i)^3* T(i)^2) * 2/3.14159265 * int(exp(-x^2),0,a(i)); % se for 1/f2: use delta method + variance formula for kernel
       end
     
for i = 1:nhospital 
gap_bmt(i) = min(bmt_R_hosp{i}(:,15)) - max(bmt_L_hosp{i}(:,15)) ; 
gap_bmt_pvalue(i) = double(1 - (1+thetaL_bmt(i)/(thetaR_bmt(i)-thetaL_bmt(i))*exp(-thetaR_bmt(i)*hospitalsize_bmt(i)*gap_bmt(i))...
                   - thetaR_bmt(i)/(thetaR_bmt(i)-thetaL_bmt(i))*exp(-thetaL_bmt(i)*hospitalsize_bmt(i)*gap_bmt(i))));
end
    
 
      
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%% KIDNEY %%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% load data 
 
kidneydata= xlsread('kerneldata_kidney.xls'); % [new_inlier new_outlier new_bpr ph_billed_3_4 inlier_thres outlier_thres norm_bill_less_outlier vol sect1 sect2 sect3 sect hospital,, abs(dis from q2)]
nhospital = max(kidneydata(:,13)); % number of hospitals
 
kidney_L = kidneydata;
kidney_L((kidneydata(:,12) ~= 2), :) = []; 
kidney_R = kidneydata;
kidney_R((kidneydata(:,12) ~= 3), :) = [];
   
kidney_LR = [kidney_L; kidney_R];

kidney_L_hosp = cell([nhospital 1]);
kidney_R_hosp = cell([nhospital 1]);

for i = 1:nhospital 
kidney_L_hosp{i} = kidney_L;
kidney_L_hosp{i}((kidney_L(:,13) ~= i), :) = [];
kidney_R_hosp{i} = kidney_R;
kidney_R_hosp{i}((kidney_R(:,13) ~= i), :) = [];
hospitalsize_kidney(i)  =  sum(kidneydata(:,13) == i);
end
  
 
% generate Y (q variable)
Ykidney_L = kidney_L(:,14); 
Ykidney_R = kidney_R(:,14); 
     
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% L kernel density, KIDNEY, original Y %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
thetaL_kidney = zeros(nhospital,1); % 
varslopeL_kidney = zeros(nhospital,1);  

 
for i = 1:nhospital  
h(i) =  1.3643*0.8918 * (length(kidney_L_hosp{i}(:,1)))^-0.2*min( std(kidney_L_hosp{i}(:,14)),(quantile(kidney_L_hosp{i}(:,14),.75)-quantile(kidney_L_hosp{i}(:,14),.25))/1.349) ; % L silverman      
a(i) = max(kidney_L_hosp{i}(:,14))/h(i); 
T(i) =  sqrt(2/3.14159265) * int(exp(-0.5*x^2),0,a(i));    
end

     for i = 1:nhospital % kernel density for each hospital
           for j = 1:size(kidney_L,1);
               if kidney_L(j,13) == i
                  thetaL_kidney(i) = thetaL_kidney(i) + 2/sqrt(2*pi)*exp(-0.5* (Ykidney_L(j)/h(i))^2);
               end
           end
           thetaL_kidney(i) = thetaL_kidney(i) / (hospitalsize_kidney(i)* T(i)*h(i)); 
     end 
 
 
    for i = 1:nhospital % kernel density for each hospital
          varslopeL_kidney(i) =  1/(hospitalsize_kidney(i) *h(i)*thetaL_kidney(i)^3)* 2/(T(i)^2*3.14159265) * int(exp(-x^2),0,a(i)); % se for 1/f1: use delta method + variance formula for kernel 
    end
 
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% R kernel density, KIDNEY, original Y %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
thetaR_kidney = zeros(nhospital,1); %
varslopeR_kidney = zeros(nhospital,1);  

  
for i = 1:nhospital  
h(i) =  1.3643*0.8918 * (length(kidney_R_hosp{i}(:,1)))^-0.2*min ( std(kidney_R_hosp{i}(:,14)),(quantile(kidney_R_hosp{i}(:,14),.75)-quantile(kidney_R_hosp{i}(:,14),.25))/1.349) ; % L silverman      
a(i) = max(kidney_R_hosp{i}(:,14))/h(i); 
T(i) =  sqrt(2/3.14159265) * int(exp(-0.5*x^2),0,a(i));    
end

     for i = 1:nhospital % kernel density for each hospital
           for j = 1:size(kidney_R,1);
               if kidney_R(j,13) == i
                  thetaR_kidney(i) = thetaR_kidney(i) + 2/sqrt(2*pi)*exp(-0.5* (Ykidney_R(j)/h(i))^2);
               end
           end
           thetaR_kidney(i) = thetaR_kidney(i) / (hospitalsize_kidney(i)*h(i)*T(i));            
    end
  
     for i = 1:nhospital % kernel density for each hospital
        varslopeR_kidney(i) =  1/(hospitalsize_kidney(i)*h(i)*thetaR_kidney(i)^3*T(i)^2)* 2/3.14159265 * int(exp(-x^2),0,a(i)); % se for 1/f2: use delta method + variance formula for kernel
       end
  
  
for i = 1:nhospital % kernel density for each hospital
     gap_kidney(i) = min(kidney_R_hosp{i}(:,15)) - max(kidney_L_hosp{i}(:,15)) ; 
     gap_kidney_pvalue(i) = double(1 - (1+thetaL_kidney(i)/(thetaR_kidney(i)-thetaL_kidney(i))*exp(-thetaR_kidney(i)*hospitalsize_kidney(i)*gap_kidney(i))...
                   - thetaR_kidney(i)/(thetaR_kidney(i)-thetaL_kidney(i))*exp(-thetaL_kidney(i)*hospitalsize_kidney(i)*gap_kidney(i))));
end    
      
      
      
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%% LIVER %%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
% load data 
liverdata= xlsread('kerneldata_liver.xls'); 
nhospital = max(liverdata(:,13)); % number of hospitals
   
  

liver_L = liverdata;
liver_L((liverdata(:,12) ~= 2), :) = []; 
liver_R = liverdata;
liver_R((liverdata(:,12) ~= 3), :) = [];
  liver_LR = [liver_L; liver_R];
  
  
liver_L_hosp = cell([nhospital 1]);
liver_R_hosp = cell([nhospital 1]);

for i = 1:nhospital 
liver_L_hosp{i} = liver_L;
liver_L_hosp{i}((liver_L(:,13) ~= i), :) = [];
liver_R_hosp{i} = liver_R;
liver_R_hosp{i}((liver_R(:,13) ~= i), :) = [];
hospitalsize_liver(i)  =  sum(liverdata(:,13) == i);
end
    
     
% generate Y (q variable)
Yliver_L = liver_L(:,14); 
Yliver_R = liver_R(:,14); 
     
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% L kernel density, LIVER, original Y %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
thetaL_liver = zeros(nhospital,1); %
varslopeL_liver = zeros(nhospital,1);  
 
for i = 1:nhospital
    h(i) = 1.3643*0.8918 * (length(liver_L_hosp{i}(:,1)))^-0.2*min( std(liver_L_hosp{i}(:,14)),(quantile(liver_L_hosp{i}(:,14),.75)-quantile(liver_L_hosp{i}(:,14),.25))/1.349) ; % L silverman  
    a(i) = max(liver_L_hosp{i}(:,14))/h(i); 
    T(i) =  sqrt(2/3.14159265) * int(exp(-0.5*x^2),0,a(i));    
end

     for i = 1:nhospital % kernel density for each hospital
           for j = 1:size(liver_L,1);
               if liver_L(j,13) == i
                  thetaL_liver(i) = thetaL_liver(i) + 2/sqrt(2*pi)*exp(-0.5* (Yliver_L(j)/h(i))^2);
               end
           end
           thetaL_liver(i) = thetaL_liver(i) / (hospitalsize_liver(i)*T(i)*h(i)); 
     end 
    
     for i = 1:nhospital % kernel density for each hospital
         varslopeL_liver(i) =  1/(hospitalsize_liver(i)*h(i)*thetaL_liver(i)^3)* 2/(3.14159265* T(i)^2) * int(exp(-x^2),0,a(i)) ; % se for 1/f1: use delta method + variance formula for kernel 
     end
  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% R kernel density, LIVER, original Y %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
thetaR_liver = zeros(nhospital,1); % 
varslopeR_liver = zeros(nhospital,1);  
 
for i = 1:nhospital
    h(i) =   1.3643*0.8918 * (length(liver_R_hosp{i}(:,1)))^-0.2*min( std(liver_R_hosp{i}(:,14)),(quantile(liver_R_hosp{i}(:,14),.75)-quantile(liver_R_hosp{i}(:,14),.25))/1.349) ; % L silverman  
    a(i) = max(liver_R_hosp{i}(:,14))/h(i); 
    T(i) =  sqrt(2/3.14159265) * int(exp(-0.5*x^2),0,a(i));    
end

     for i = 1:nhospital % kernel density for each hospital
           for j = 1:size(liver_R,1);
               if liver_R(j,13) == i
                  thetaR_liver(i) = thetaR_liver(i) + 2/sqrt(2*pi)*exp(-0.5* (Yliver_R(j)/h(i))^2);
               end
           end
           thetaR_liver(i) = thetaR_liver(i) / (hospitalsize_liver(i)*h(i)*T(i));        
     end
     
     for i = 1:nhospital % kernel density for each hospital
          varslopeR_liver(i) =  1/(hospitalsize_liver(i)*h(i)*thetaR_liver(i)^3*T(i)^2) * 2/3.14159265 * int(exp(-x^2),0,a(i)); % se for 1/f2: use delta method + variance formula for kernel
     end
 
 for i = 1:nhospital      
gap_liver(i) = min(liver_R_hosp{i}(:,15)) - max(liver_L_hosp{i}(:,15)) ; 
gap_liver_pvalue(i) = double(1 - (1+thetaL_liver(i)/(thetaR_liver(i)-thetaL_liver(i))*exp(-thetaR_liver(i)*hospitalsize_liver(i)*gap_liver(i))...
                   - thetaR_liver(i)/(thetaR_liver(i)-thetaL_liver(i))*exp(-thetaL_liver(i)*hospitalsize_liver(i)*gap_liver(i))));
 end
 
  

 
slopeL_bmt = 1 ./thetaL_bmt* 100
slopeR_bmt = 1 ./thetaR_bmt* 100
phi4_bmt = slopeR_bmt - slopeL_bmt
sephi4_bmt = sqrt(double(varslopeL_bmt+varslopeR_bmt))* 100
t_bmt = phi4_bmt ./ sephi4_bmt 

 
slopeL_kidney = 1 ./thetaL_kidney* 100
slopeR_kidney = 1 ./thetaR_kidney* 100
phi4_kidney = slopeR_kidney - slopeL_kidney
sephi4_kidney = sqrt(double(varslopeL_kidney+varslopeR_kidney))* 100
t_kidney = phi4_kidney ./ sephi4_kidney   
 
slopeL_liver = 1 ./thetaL_liver* 100
slopeR_liver = 1 ./thetaR_liver* 100
phi4_liver = slopeR_liver - slopeL_liver
sephi4_liver = sqrt(double(varslopeL_liver+varslopeR_liver))* 100
t_liver = phi4_liver ./ sephi4_liver 
     
 

gap_bmt* 100
gap_bmt_pvalue
gap_kidney* 100
gap_kidney_pvalue
gap_liver* 100
gap_liver_pvalue


     