%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Kernel estimation of phi4
%%%%%%%% estimation Hospital by hospital
%%%%%%%%%% Original Y
clear

syms x;   
   

    
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%% KIDNEY %%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


% load data  
kidneydata= xlsread('kerneldata_kidney_control.xls'); 
nhospital = max(kidneydata(:,8)); % number of hospitals
 
kidney_L = kidneydata;
for i = size(kidneydata,1):-1:1;
    if kidneydata(i,7) ~= 2  ;
       kidney_L(i,:) = [];
    end
end
 
kidney_R = kidneydata;
for i = size(kidneydata,1):-1:1;
    if kidneydata(i,7) ~= 3;
       kidney_R(i,:) = [];
    end
end
 
 
kidney_L_hosp = cell([nhospital 1]);
kidney_R_hosp = cell([nhospital 1]);

for i = 1:nhospital 
kidney_L_hosp{i} = kidney_L;
kidney_L_hosp{i}((kidney_L(:,8) ~= i), :) = [];
kidney_R_hosp{i} = kidney_R;
kidney_R_hosp{i}((kidney_R(:,8) ~= i), :) = [];
hospitalsize_kidney(i)  =  sum(kidneydata(:,8) == i);
end 
 
  
 
% generate Y (q variable)
Ykidney_L =  kidney_L(:,9); 
Ykidney_R = kidney_R(:,9)  ; 
     
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% L kernel density, KIDNEY, original Y %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
thetaL_kidney = zeros(nhospital,1); %
  

for i = 1:nhospital 
h(i) =  1.3643*0.8918 * (length(kidney_L_hosp{i}(:,1)))^-0.2*min( std(kidney_L_hosp{i}(:,9)),(quantile(kidney_L_hosp{i}(:,9),.75)-quantile(kidney_L_hosp{i}(:,9),.25))/1.349) ; % L silverman  
a(i) = max(kidney_L_hosp{i}(:,9))/h(i);
T(i) =  sqrt(2/3.14159265) * int(exp(-0.5*x^2),0,a(i));   
end 

      for i = 1:nhospital % kernel density for each hospital
           for j = 1:size(kidney_L,1);
               if kidney_L(j,8) == i
                  thetaL_kidney(i) = thetaL_kidney(i) + 2/sqrt(2*pi)*exp(-0.5* (Ykidney_L(j)/h(i))^2);
               end
           end
           thetaL_kidney(i) = thetaL_kidney(i) / (hospitalsize_kidney(i)*T(i)*h(i)); 
     end
 
     
     for i = 1:nhospital % kernel density for each hospital
        varslopeL_kidney(i) =  1/(hospitalsize_kidney(i)*h(i)*thetaL_kidney(i)^3) *   2/(3.14159265*T(i)^2) * int(exp(-x^2),0,a(i)) ; % se for 1/f1: use delta method + variance formula for kernel 
     end
  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% R kernel density, KIDNEY, original Y %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
thetaR_kidney = zeros(nhospital,1); %
  
for i = 1:nhospital 
h(i) =  1.3643*0.8918 * (length(kidney_R_hosp{i}(:,1)))^-0.2*min( std(kidney_R_hosp{i}(:,9)),(quantile(kidney_R_hosp{i}(:,9),.75)-quantile(kidney_R_hosp{i}(:,9),.25))/1.349) ; % L silverman  
a(i) = max(kidney_R_hosp{i}(:,9))/h(i);
T(i) =  sqrt(2/3.14159265) * int(exp(-0.5*x^2),0,a(i));   
end 
      for i = 1:nhospital % kernel density for each hospital
           for j = 1:size(kidney_R,1);
               if kidney_R(j,8) == i
                  thetaR_kidney(i) = thetaR_kidney(i) + 2/sqrt(2*pi)*exp(-0.5* (Ykidney_R(j)/h(i))^2);
               end
           end
           thetaR_kidney(i) = thetaR_kidney(i) / (hospitalsize_kidney(i)*h(i)*T(i));            
     end
   
 
     for i = 1:nhospital % kernel density for each hospital
        varslopeR_kidney(i) =  1/(hospitalsize_kidney(i)*h(i)*thetaR_kidney(i)^3*T(i)^2) * 2/3.14159265 * int(exp(-x^2),0,a(i)) ; % se for 1/f2: use delta method + variance formula for kernel
     end
 
for i = 1:nhospital 
 gap_kidney(i) = min(kidney_R_hosp{i}(:,10)) - max(kidney_L_hosp{i}(:,10)) ;
gap_kidney_pvalue(i) = double(1 - (1+thetaL_kidney(i)/(thetaR_kidney(i)-thetaL_kidney(i))*exp(-thetaR_kidney(i)*hospitalsize_kidney(i)*gap_kidney(i))...
                   - thetaR_kidney(i)/(thetaR_kidney(i)-thetaL_kidney(i))*exp(-thetaL_kidney(i)*hospitalsize_kidney(i)*gap_kidney(i))));
end   
  

% load data 
 
liverdata= xlsread('kerneldata_liver_control.xls'); 
nhospital = max(liverdata(:,8)); % number of hospitals
 
liver_L = liverdata;
for i = size(liverdata,1):-1:1;
    if liverdata(i,7) ~= 2  ;
       liver_L(i,:) = [];
    end
end
 
liver_R = liverdata;
for i = size(liverdata,1):-1:1;
    if liverdata(i,7) ~= 3;
       liver_R(i,:) = [];
    end
end
 
liver_L_hosp = cell([nhospital 1]);
liver_R_hosp = cell([nhospital 1]);

for i = 1:nhospital 
liver_L_hosp{i} = liver_L;
liver_L_hosp{i}((liver_L(:,8) ~= i), :) = [];
liver_R_hosp{i} = liver_R;
liver_R_hosp{i}((liver_R(:,8) ~= i), :) = [];
hospitalsize_liver(i)  =  sum(liverdata(:,8) == i);
end 
  
   
% generate Y (q variable)
Yliver_L =  liver_L(:,9); 
Yliver_R = liver_R(:,9); 
     
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% L kernel density, LIVER, original Y %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
thetaL_liver = zeros(nhospital,1); %
 
for i = 1:nhospital 
h(i) =  1.3643*0.8918 * (length(liver_L_hosp{i}(:,1)))^-0.2*min( std(liver_L_hosp{i}(:,9)),(quantile(liver_L_hosp{i}(:,9),.75)-quantile(liver_L_hosp{i}(:,9),.25))/1.349) ; % L silverman  
a(i) = max(liver_L_hosp{i}(:,9))/h(i);
T(i)  =  sqrt(2/3.14159265) * int(exp(-0.5*x^2),0,a(i));   
end

     for i = 1:nhospital % kernel density for each hospital
           for j = 1:size(liver_L,1);
               if liver_L(j,8) == i
                  thetaL_liver(i) = thetaL_liver(i) + 2/sqrt(2*pi)*exp(-0.5* (Yliver_L(j)/h(i) )^2);
               end
           end
           thetaL_liver(i) = thetaL_liver(i) / (hospitalsize_liver(i)*T(i)*h(i)); 
     end
   
     for i = 1:nhospital % kernel density for each hospital
        varslopeL_liver(i) =  1/(hospitalsize_liver(i)*h(i) *thetaL_liver(i)^3) * 2/(3.14159265*T(i)^2) * int(exp(-x^2),0,a(i)) ; % se for 1/f1: use delta method + variance formula for kernel 
     end
  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% R kernel density, LIVER, original Y %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
thetaR_liver = zeros(nhospital,1); %
 
for i = 1:nhospital 
h(i) =  1.3643*0.8918 * (length(liver_R_hosp{i}(:,1)))^-0.2*min( std(liver_R_hosp{i}(:,9)),(quantile(liver_R_hosp{i}(:,9),.75)-quantile(liver_R_hosp{i}(:,9),.25))/1.349) ; % L silverman  
a(i) = max(liver_R_hosp{i}(:,9))/h(i);
T(i)  =  sqrt(2/3.14159265) * int(exp(-0.5*x^2),0,a(i));   
end

     for i = 1:nhospital % kernel density for each hospital
           for j = 1:size(liver_R,1);
               if liver_R(j,8) == i
                  thetaR_liver(i) = thetaR_liver(i) + 2/sqrt(2*pi)*exp(-0.5* (Yliver_R(j)/h(i) )^2);
               end
           end
           thetaR_liver(i) = thetaR_liver(i) / (hospitalsize_liver(i)*h(i)*T(i));            
     end
   
 
     for i = 1:nhospital % kernel density for each hospital
        varslopeR_liver(i) = 1/(hospitalsize_liver(i)*h(i) *thetaR_liver(i)^3*T(i)^2) * 2/3.14159265 * int(exp(-x^2),0,a(i)) ; % se for 1/f2: use delta method + variance formula for kernel
     end
 

for i = 1:nhospital
gap_liver(i) = min(liver_R_hosp{i}(:,10)) - max(liver_L_hosp{i}(:,10)) ;
gap_liver_pvalue(i) = double(1 - (1+thetaL_liver(i)/(thetaR_liver(i)-thetaL_liver(i))*exp(-thetaR_liver(i)*hospitalsize_liver(i)*gap_liver(i))...
                   - thetaR_liver(i)/(thetaR_liver(i)-thetaL_liver(i))*exp(-thetaL_liver(i)*hospitalsize_liver(i)*gap_liver(i))));
end
 
 
slopeL_kidney = 1 ./thetaL_kidney* 100
slopeR_kidney = 1 ./thetaR_kidney* 100
phi4_kidney = slopeR_kidney - slopeL_kidney
sephi4_kidney = sqrt(double(varslopeL_kidney  +  varslopeR_kidney))'* 100
t_kidney = phi4_kidney ./ sephi4_kidney   
 
slopeL_liver = 1 ./thetaL_liver * 100
slopeR_liver = 1 ./thetaR_liver* 100
phi4_liver = slopeR_liver - slopeL_liver
sephi4_liver = sqrt(double(varslopeL_liver+varslopeR_liver))'* 100
t_liver = phi4_liver ./ sephi4_liver 
     
 
gap_kidney* 100
gap_kidney_pvalue
gap_liver* 100
gap_liver_pvalue




     